﻿/*
  Copyright 2007 Takashi Oguma

  This file is part of SendToCMD.

  SendToCMD is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  SendToCMD is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with SendToCMD; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#pragma once

// C++ headers
#include <string>
#include <sstream>
#include <vector>
#include <exception>
#include <stdexcept>

// Windows headers
#define  _WIN32_WINNT 0x0501
#include <windows.h>
#include <winuser.h>

// private headers
#include "debug.h"


// MACROs
#define FOREACH(iter_type_, iter_, container_)\
    for (iter_type_ (iter_) = (container_).begin(); (iter_) != (container_).end(); (iter_)++)

#define BOOL2bool(b) ((b != 0) ? true : false)

namespace bearmini
{
    typedef std::vector<std::wstring> wstring_vector;
}