﻿/*
  Copyright 2007 Takashi Oguma

  This file is part of SendToCMD.

  SendToCMD is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  SendToCMD is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with SendToCMD; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#pragma once

#include "Foundation.h"

namespace bearmini
{

    class Shortcut
    {
    public:
        static ::HRESULT Create(
            const std::wstring& pathLinkFile,   // ショートカットの絶対パス
            const std::wstring& pathTargetFile, // ターゲットファイル
            const std::wstring& description,    // 説明
            const std::wstring& args,           // 引数
            const std::wstring& workingDir,     // 作業ディレクトリ
            const std::wstring& pathIcon,       // アイコンの場所
            int iIcon    = 0,                   // アイコンのインデックス
            int iShowCmd = SW_SHOWNORMAL,       // ウィンドウスタイル
            bool runasAdmin = false             // 互換性タブの「管理者として実行」をチェックするかどうか
        );
    };

}